/* tslint:disable */
/* eslint-disable */
/**
 * Coscine Web API
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import type { Configuration } from '../../configuration';
import type { AxiosPromise, AxiosInstance, RawAxiosRequestConfig } from 'axios';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, type RequestArgs, BaseAPI, RequiredError, operationServerMap } from '../../base';
// @ts-ignore
import type { ActivityLogDtoPagedResponse } from '../../@coscine/model';
// @ts-ignore
import type { CoscineHttpMethod } from '../../@coscine/model';
// @ts-ignore
import type { DeployedGraphDtoPagedResponse } from '../../@coscine/model';
// @ts-ignore
import type { MetadataUpdateAdminParameters } from '../../@coscine/model';
// @ts-ignore
import type { ProjectAdminDtoPagedResponse } from '../../@coscine/model';
// @ts-ignore
import type { RdfDefinitionDtoResponse } from '../../@coscine/model';
// @ts-ignore
import type { RdfFormat } from '../../@coscine/model';
// @ts-ignore
import type { RdfPatchDocumentDto } from '../../@coscine/model';
// @ts-ignore
import type { ResourceAdminDtoPagedResponse } from '../../@coscine/model';
// @ts-ignore
import type { UserDtoPagedResponse } from '../../@coscine/model';
/**
 * AdminApi - axios parameter creator
 * @export
 */
export const AdminApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2AdminOptions: async (options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v2/admin`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'OPTIONS', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Retrieves all activity logs.
         * @param {string} [activityTimestampBefore] The activity timestamp date before which activity logs should be retrieved.
         * @param {string} [activityTimestampAfter] The activity timestamp date after which activity logs should be retrieved.
         * @param {string} [guid] The GUID for which activity logs should be retrieved. Can be a project, resource or other ID.
         * @param {string} [userId] The user ID for which activity logs should be retrieved.
         * @param {string} [regularExpression] The regular expression to filter activity logs\&#39; API path by. The regex must be a valid, already escaped string.
         * @param {CoscineHttpMethod} [httpMethod] The http method to filter activity logs by.
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {number} [pageSize] The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAllActivityLogs: async (activityTimestampBefore?: string, activityTimestampAfter?: string, guid?: string, userId?: string, regularExpression?: string, httpMethod?: CoscineHttpMethod, pageNumber?: number, pageSize?: number, orderBy?: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v2/admin/activity-logs`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (activityTimestampBefore !== undefined) {
                localVarQueryParameter['ActivityTimestampBefore'] = (activityTimestampBefore as any instanceof Date) ?
                    (activityTimestampBefore as any).toISOString() :
                    activityTimestampBefore;
            }

            if (activityTimestampAfter !== undefined) {
                localVarQueryParameter['ActivityTimestampAfter'] = (activityTimestampAfter as any instanceof Date) ?
                    (activityTimestampAfter as any).toISOString() :
                    activityTimestampAfter;
            }

            if (guid !== undefined) {
                localVarQueryParameter['Guid'] = guid;
            }

            if (userId !== undefined) {
                localVarQueryParameter['UserId'] = userId;
            }

            if (regularExpression !== undefined) {
                localVarQueryParameter['RegularExpression'] = regularExpression;
            }

            if (httpMethod !== undefined) {
                localVarQueryParameter['HttpMethod'] = httpMethod;
            }

            if (pageNumber !== undefined) {
                localVarQueryParameter['PageNumber'] = pageNumber;
            }

            if (pageSize !== undefined) {
                localVarQueryParameter['PageSize'] = pageSize;
            }

            if (orderBy !== undefined) {
                localVarQueryParameter['OrderBy'] = orderBy;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Retrieves all projects.
         * @param {boolean} [topLevel] Gets or sets a value indicating whether to filter top-level projects.
         * @param {boolean} [includeDeleted] Gets or sets a value indicating whether to include deleted projects in the results.
         * @param {boolean} [includeQuotas] Gets or sets a value indicating whether to include quotas in the results.
         * @param {boolean} [includePublicationRequests] Gets or sets a value indicating whether to include project publication requests in the results.
         * @param {number} [pageSize] Number of items per page. The maximum number of items per page is &#x60;250&#x60;.
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAllProjects: async (topLevel?: boolean, includeDeleted?: boolean, includeQuotas?: boolean, includePublicationRequests?: boolean, pageSize?: number, pageNumber?: number, orderBy?: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v2/admin/projects`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (topLevel !== undefined) {
                localVarQueryParameter['TopLevel'] = topLevel;
            }

            if (includeDeleted !== undefined) {
                localVarQueryParameter['IncludeDeleted'] = includeDeleted;
            }

            if (includeQuotas !== undefined) {
                localVarQueryParameter['IncludeQuotas'] = includeQuotas;
            }

            if (includePublicationRequests !== undefined) {
                localVarQueryParameter['IncludePublicationRequests'] = includePublicationRequests;
            }

            if (pageSize !== undefined) {
                localVarQueryParameter['PageSize'] = pageSize;
            }

            if (pageNumber !== undefined) {
                localVarQueryParameter['PageNumber'] = pageNumber;
            }

            if (orderBy !== undefined) {
                localVarQueryParameter['OrderBy'] = orderBy;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Retrieves all resources.
         * @param {boolean} [includeDeleted] Value indicating whether to include deleted resources.
         * @param {boolean} [includeQuotas] Value indicating whether to include individual resource quotas.
         * @param {number} [pageSize] Number of items per page. The maximum number of items per page is &#x60;250&#x60;.
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAllResources: async (includeDeleted?: boolean, includeQuotas?: boolean, pageSize?: number, pageNumber?: number, orderBy?: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v2/admin/resources`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (includeDeleted !== undefined) {
                localVarQueryParameter['IncludeDeleted'] = includeDeleted;
            }

            if (includeQuotas !== undefined) {
                localVarQueryParameter['IncludeQuotas'] = includeQuotas;
            }

            if (pageSize !== undefined) {
                localVarQueryParameter['PageSize'] = pageSize;
            }

            if (pageNumber !== undefined) {
                localVarQueryParameter['PageNumber'] = pageNumber;
            }

            if (orderBy !== undefined) {
                localVarQueryParameter['OrderBy'] = orderBy;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Retrieves all users.
         * @param {boolean} [tosAccepted] Gets or sets a value indicating whether the terms of service have been accepted by the user.
         * @param {number} [pageSize] Number of items per page. The maximum number of items per page is &#x60;250&#x60;.
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAllUsers: async (tosAccepted?: boolean, pageSize?: number, pageNumber?: number, orderBy?: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v2/admin/users`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (tosAccepted !== undefined) {
                localVarQueryParameter['TosAccepted'] = tosAccepted;
            }

            if (pageSize !== undefined) {
                localVarQueryParameter['PageSize'] = pageSize;
            }

            if (pageNumber !== undefined) {
                localVarQueryParameter['PageNumber'] = pageNumber;
            }

            if (orderBy !== undefined) {
                localVarQueryParameter['OrderBy'] = orderBy;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Gets all deployed graphs.
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {number} [pageSize] The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getDeployedGraphs: async (pageNumber?: number, pageSize?: number, orderBy?: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v2/admin/graphs`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (pageNumber !== undefined) {
                localVarQueryParameter['PageNumber'] = pageNumber;
            }

            if (pageSize !== undefined) {
                localVarQueryParameter['PageSize'] = pageSize;
            }

            if (orderBy !== undefined) {
                localVarQueryParameter['OrderBy'] = orderBy;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Gets a metadata graph.
         * @param {string} graph The absolute URI of the graph to get.
         * @param {RdfFormat} [format] Gets or sets the RDF format.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getMetadataGraph: async (graph: string, format?: RdfFormat, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'graph' is not null or undefined
            assertParamExists('getMetadataGraph', 'graph', graph)
            const localVarPath = `/api/v2/admin/metadata/{graph}`
                .replace(`{${"graph"}}`, encodeURIComponent(String(graph)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (format !== undefined) {
                localVarQueryParameter['Format'] = format;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Patches a metadata graph.
         * @param {string} graph The absolute URI of the graph to patch.
         * @param {RdfPatchDocumentDto} [rdfPatchDocumentDto] The well-formed RDF patch document containing the changes as operations to be applied to the graph.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        patchMetadata: async (graph: string, rdfPatchDocumentDto?: RdfPatchDocumentDto, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'graph' is not null or undefined
            assertParamExists('patchMetadata', 'graph', graph)
            const localVarPath = `/api/v2/admin/metadata/{graph}`
                .replace(`{${"graph"}}`, encodeURIComponent(String(graph)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PATCH', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(rdfPatchDocumentDto, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Updates a metadata graph.
         * @param {string} graph The absolute URI of the graph to update.
         * @param {MetadataUpdateAdminParameters} [metadataUpdateAdminParameters] The metadata update admin parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateMetadataGraph: async (graph: string, metadataUpdateAdminParameters?: MetadataUpdateAdminParameters, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'graph' is not null or undefined
            assertParamExists('updateMetadataGraph', 'graph', graph)
            const localVarPath = `/api/v2/admin/metadata/{graph}`
                .replace(`{${"graph"}}`, encodeURIComponent(String(graph)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(metadataUpdateAdminParameters, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * AdminApi - functional programming interface
 * @export
 */
export const AdminApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = AdminApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV2AdminOptions(options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV2AdminOptions(options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['AdminApi.apiV2AdminOptions']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Retrieves all activity logs.
         * @param {string} [activityTimestampBefore] The activity timestamp date before which activity logs should be retrieved.
         * @param {string} [activityTimestampAfter] The activity timestamp date after which activity logs should be retrieved.
         * @param {string} [guid] The GUID for which activity logs should be retrieved. Can be a project, resource or other ID.
         * @param {string} [userId] The user ID for which activity logs should be retrieved.
         * @param {string} [regularExpression] The regular expression to filter activity logs\&#39; API path by. The regex must be a valid, already escaped string.
         * @param {CoscineHttpMethod} [httpMethod] The http method to filter activity logs by.
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {number} [pageSize] The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getAllActivityLogs(activityTimestampBefore?: string, activityTimestampAfter?: string, guid?: string, userId?: string, regularExpression?: string, httpMethod?: CoscineHttpMethod, pageNumber?: number, pageSize?: number, orderBy?: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ActivityLogDtoPagedResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getAllActivityLogs(activityTimestampBefore, activityTimestampAfter, guid, userId, regularExpression, httpMethod, pageNumber, pageSize, orderBy, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['AdminApi.getAllActivityLogs']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Retrieves all projects.
         * @param {boolean} [topLevel] Gets or sets a value indicating whether to filter top-level projects.
         * @param {boolean} [includeDeleted] Gets or sets a value indicating whether to include deleted projects in the results.
         * @param {boolean} [includeQuotas] Gets or sets a value indicating whether to include quotas in the results.
         * @param {boolean} [includePublicationRequests] Gets or sets a value indicating whether to include project publication requests in the results.
         * @param {number} [pageSize] Number of items per page. The maximum number of items per page is &#x60;250&#x60;.
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getAllProjects(topLevel?: boolean, includeDeleted?: boolean, includeQuotas?: boolean, includePublicationRequests?: boolean, pageSize?: number, pageNumber?: number, orderBy?: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ProjectAdminDtoPagedResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getAllProjects(topLevel, includeDeleted, includeQuotas, includePublicationRequests, pageSize, pageNumber, orderBy, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['AdminApi.getAllProjects']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Retrieves all resources.
         * @param {boolean} [includeDeleted] Value indicating whether to include deleted resources.
         * @param {boolean} [includeQuotas] Value indicating whether to include individual resource quotas.
         * @param {number} [pageSize] Number of items per page. The maximum number of items per page is &#x60;250&#x60;.
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getAllResources(includeDeleted?: boolean, includeQuotas?: boolean, pageSize?: number, pageNumber?: number, orderBy?: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ResourceAdminDtoPagedResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getAllResources(includeDeleted, includeQuotas, pageSize, pageNumber, orderBy, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['AdminApi.getAllResources']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Retrieves all users.
         * @param {boolean} [tosAccepted] Gets or sets a value indicating whether the terms of service have been accepted by the user.
         * @param {number} [pageSize] Number of items per page. The maximum number of items per page is &#x60;250&#x60;.
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getAllUsers(tosAccepted?: boolean, pageSize?: number, pageNumber?: number, orderBy?: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<UserDtoPagedResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getAllUsers(tosAccepted, pageSize, pageNumber, orderBy, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['AdminApi.getAllUsers']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Gets all deployed graphs.
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {number} [pageSize] The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getDeployedGraphs(pageNumber?: number, pageSize?: number, orderBy?: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DeployedGraphDtoPagedResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getDeployedGraphs(pageNumber, pageSize, orderBy, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['AdminApi.getDeployedGraphs']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Gets a metadata graph.
         * @param {string} graph The absolute URI of the graph to get.
         * @param {RdfFormat} [format] Gets or sets the RDF format.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getMetadataGraph(graph: string, format?: RdfFormat, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<RdfDefinitionDtoResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getMetadataGraph(graph, format, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['AdminApi.getMetadataGraph']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Patches a metadata graph.
         * @param {string} graph The absolute URI of the graph to patch.
         * @param {RdfPatchDocumentDto} [rdfPatchDocumentDto] The well-formed RDF patch document containing the changes as operations to be applied to the graph.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async patchMetadata(graph: string, rdfPatchDocumentDto?: RdfPatchDocumentDto, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.patchMetadata(graph, rdfPatchDocumentDto, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['AdminApi.patchMetadata']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Updates a metadata graph.
         * @param {string} graph The absolute URI of the graph to update.
         * @param {MetadataUpdateAdminParameters} [metadataUpdateAdminParameters] The metadata update admin parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async updateMetadataGraph(graph: string, metadataUpdateAdminParameters?: MetadataUpdateAdminParameters, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.updateMetadataGraph(graph, metadataUpdateAdminParameters, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['AdminApi.updateMetadataGraph']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
    }
};

/**
 * AdminApi - factory interface
 * @export
 */
export const AdminApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = AdminApiFp(configuration)
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2AdminOptions(options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.apiV2AdminOptions(options).then((request) => request(axios, basePath));
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Retrieves all activity logs.
         * @param {AdminApiGetAllActivityLogsRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAllActivityLogs(requestParameters: AdminApiGetAllActivityLogsRequest = {}, options?: RawAxiosRequestConfig): AxiosPromise<ActivityLogDtoPagedResponse> {
            return localVarFp.getAllActivityLogs(requestParameters.activityTimestampBefore, requestParameters.activityTimestampAfter, requestParameters.guid, requestParameters.userId, requestParameters.regularExpression, requestParameters.httpMethod, requestParameters.pageNumber, requestParameters.pageSize, requestParameters.orderBy, options).then((request) => request(axios, basePath));
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Retrieves all projects.
         * @param {AdminApiGetAllProjectsRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAllProjects(requestParameters: AdminApiGetAllProjectsRequest = {}, options?: RawAxiosRequestConfig): AxiosPromise<ProjectAdminDtoPagedResponse> {
            return localVarFp.getAllProjects(requestParameters.topLevel, requestParameters.includeDeleted, requestParameters.includeQuotas, requestParameters.includePublicationRequests, requestParameters.pageSize, requestParameters.pageNumber, requestParameters.orderBy, options).then((request) => request(axios, basePath));
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Retrieves all resources.
         * @param {AdminApiGetAllResourcesRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAllResources(requestParameters: AdminApiGetAllResourcesRequest = {}, options?: RawAxiosRequestConfig): AxiosPromise<ResourceAdminDtoPagedResponse> {
            return localVarFp.getAllResources(requestParameters.includeDeleted, requestParameters.includeQuotas, requestParameters.pageSize, requestParameters.pageNumber, requestParameters.orderBy, options).then((request) => request(axios, basePath));
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Retrieves all users.
         * @param {AdminApiGetAllUsersRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAllUsers(requestParameters: AdminApiGetAllUsersRequest = {}, options?: RawAxiosRequestConfig): AxiosPromise<UserDtoPagedResponse> {
            return localVarFp.getAllUsers(requestParameters.tosAccepted, requestParameters.pageSize, requestParameters.pageNumber, requestParameters.orderBy, options).then((request) => request(axios, basePath));
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Gets all deployed graphs.
         * @param {AdminApiGetDeployedGraphsRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getDeployedGraphs(requestParameters: AdminApiGetDeployedGraphsRequest = {}, options?: RawAxiosRequestConfig): AxiosPromise<DeployedGraphDtoPagedResponse> {
            return localVarFp.getDeployedGraphs(requestParameters.pageNumber, requestParameters.pageSize, requestParameters.orderBy, options).then((request) => request(axios, basePath));
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Gets a metadata graph.
         * @param {AdminApiGetMetadataGraphRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getMetadataGraph(requestParameters: AdminApiGetMetadataGraphRequest, options?: RawAxiosRequestConfig): AxiosPromise<RdfDefinitionDtoResponse> {
            return localVarFp.getMetadataGraph(requestParameters.graph, requestParameters.format, options).then((request) => request(axios, basePath));
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Patches a metadata graph.
         * @param {AdminApiPatchMetadataRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        patchMetadata(requestParameters: AdminApiPatchMetadataRequest, options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.patchMetadata(requestParameters.graph, requestParameters.rdfPatchDocumentDto, options).then((request) => request(axios, basePath));
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Updates a metadata graph.
         * @param {AdminApiUpdateMetadataGraphRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateMetadataGraph(requestParameters: AdminApiUpdateMetadataGraphRequest, options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.updateMetadataGraph(requestParameters.graph, requestParameters.metadataUpdateAdminParameters, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for getAllActivityLogs operation in AdminApi.
 * @export
 * @interface AdminApiGetAllActivityLogsRequest
 */
export interface AdminApiGetAllActivityLogsRequest {
    /**
     * The activity timestamp date before which activity logs should be retrieved.
     * @type {string}
     * @memberof AdminApiGetAllActivityLogs
     */
    readonly activityTimestampBefore?: string

    /**
     * The activity timestamp date after which activity logs should be retrieved.
     * @type {string}
     * @memberof AdminApiGetAllActivityLogs
     */
    readonly activityTimestampAfter?: string

    /**
     * The GUID for which activity logs should be retrieved. Can be a project, resource or other ID.
     * @type {string}
     * @memberof AdminApiGetAllActivityLogs
     */
    readonly guid?: string

    /**
     * The user ID for which activity logs should be retrieved.
     * @type {string}
     * @memberof AdminApiGetAllActivityLogs
     */
    readonly userId?: string

    /**
     * The regular expression to filter activity logs\&#39; API path by. The regex must be a valid, already escaped string.
     * @type {string}
     * @memberof AdminApiGetAllActivityLogs
     */
    readonly regularExpression?: string

    /**
     * The http method to filter activity logs by.
     * @type {CoscineHttpMethod}
     * @memberof AdminApiGetAllActivityLogs
     */
    readonly httpMethod?: CoscineHttpMethod

    /**
     * The desired page number. Should be greater than or equal to 1. Default is 1.
     * @type {number}
     * @memberof AdminApiGetAllActivityLogs
     */
    readonly pageNumber?: number

    /**
     * The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
     * @type {number}
     * @memberof AdminApiGetAllActivityLogs
     */
    readonly pageSize?: number

    /**
     * Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
     * @type {string}
     * @memberof AdminApiGetAllActivityLogs
     */
    readonly orderBy?: string
}

/**
 * Request parameters for getAllProjects operation in AdminApi.
 * @export
 * @interface AdminApiGetAllProjectsRequest
 */
export interface AdminApiGetAllProjectsRequest {
    /**
     * Gets or sets a value indicating whether to filter top-level projects.
     * @type {boolean}
     * @memberof AdminApiGetAllProjects
     */
    readonly topLevel?: boolean

    /**
     * Gets or sets a value indicating whether to include deleted projects in the results.
     * @type {boolean}
     * @memberof AdminApiGetAllProjects
     */
    readonly includeDeleted?: boolean

    /**
     * Gets or sets a value indicating whether to include quotas in the results.
     * @type {boolean}
     * @memberof AdminApiGetAllProjects
     */
    readonly includeQuotas?: boolean

    /**
     * Gets or sets a value indicating whether to include project publication requests in the results.
     * @type {boolean}
     * @memberof AdminApiGetAllProjects
     */
    readonly includePublicationRequests?: boolean

    /**
     * Number of items per page. The maximum number of items per page is &#x60;250&#x60;.
     * @type {number}
     * @memberof AdminApiGetAllProjects
     */
    readonly pageSize?: number

    /**
     * The desired page number. Should be greater than or equal to 1. Default is 1.
     * @type {number}
     * @memberof AdminApiGetAllProjects
     */
    readonly pageNumber?: number

    /**
     * Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
     * @type {string}
     * @memberof AdminApiGetAllProjects
     */
    readonly orderBy?: string
}

/**
 * Request parameters for getAllResources operation in AdminApi.
 * @export
 * @interface AdminApiGetAllResourcesRequest
 */
export interface AdminApiGetAllResourcesRequest {
    /**
     * Value indicating whether to include deleted resources.
     * @type {boolean}
     * @memberof AdminApiGetAllResources
     */
    readonly includeDeleted?: boolean

    /**
     * Value indicating whether to include individual resource quotas.
     * @type {boolean}
     * @memberof AdminApiGetAllResources
     */
    readonly includeQuotas?: boolean

    /**
     * Number of items per page. The maximum number of items per page is &#x60;250&#x60;.
     * @type {number}
     * @memberof AdminApiGetAllResources
     */
    readonly pageSize?: number

    /**
     * The desired page number. Should be greater than or equal to 1. Default is 1.
     * @type {number}
     * @memberof AdminApiGetAllResources
     */
    readonly pageNumber?: number

    /**
     * Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
     * @type {string}
     * @memberof AdminApiGetAllResources
     */
    readonly orderBy?: string
}

/**
 * Request parameters for getAllUsers operation in AdminApi.
 * @export
 * @interface AdminApiGetAllUsersRequest
 */
export interface AdminApiGetAllUsersRequest {
    /**
     * Gets or sets a value indicating whether the terms of service have been accepted by the user.
     * @type {boolean}
     * @memberof AdminApiGetAllUsers
     */
    readonly tosAccepted?: boolean

    /**
     * Number of items per page. The maximum number of items per page is &#x60;250&#x60;.
     * @type {number}
     * @memberof AdminApiGetAllUsers
     */
    readonly pageSize?: number

    /**
     * The desired page number. Should be greater than or equal to 1. Default is 1.
     * @type {number}
     * @memberof AdminApiGetAllUsers
     */
    readonly pageNumber?: number

    /**
     * Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
     * @type {string}
     * @memberof AdminApiGetAllUsers
     */
    readonly orderBy?: string
}

/**
 * Request parameters for getDeployedGraphs operation in AdminApi.
 * @export
 * @interface AdminApiGetDeployedGraphsRequest
 */
export interface AdminApiGetDeployedGraphsRequest {
    /**
     * The desired page number. Should be greater than or equal to 1. Default is 1.
     * @type {number}
     * @memberof AdminApiGetDeployedGraphs
     */
    readonly pageNumber?: number

    /**
     * The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
     * @type {number}
     * @memberof AdminApiGetDeployedGraphs
     */
    readonly pageSize?: number

    /**
     * Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
     * @type {string}
     * @memberof AdminApiGetDeployedGraphs
     */
    readonly orderBy?: string
}

/**
 * Request parameters for getMetadataGraph operation in AdminApi.
 * @export
 * @interface AdminApiGetMetadataGraphRequest
 */
export interface AdminApiGetMetadataGraphRequest {
    /**
     * The absolute URI of the graph to get.
     * @type {string}
     * @memberof AdminApiGetMetadataGraph
     */
    readonly graph: string

    /**
     * Gets or sets the RDF format.
     * @type {RdfFormat}
     * @memberof AdminApiGetMetadataGraph
     */
    readonly format?: RdfFormat
}

/**
 * Request parameters for patchMetadata operation in AdminApi.
 * @export
 * @interface AdminApiPatchMetadataRequest
 */
export interface AdminApiPatchMetadataRequest {
    /**
     * The absolute URI of the graph to patch.
     * @type {string}
     * @memberof AdminApiPatchMetadata
     */
    readonly graph: string

    /**
     * The well-formed RDF patch document containing the changes as operations to be applied to the graph.
     * @type {RdfPatchDocumentDto}
     * @memberof AdminApiPatchMetadata
     */
    readonly rdfPatchDocumentDto?: RdfPatchDocumentDto
}

/**
 * Request parameters for updateMetadataGraph operation in AdminApi.
 * @export
 * @interface AdminApiUpdateMetadataGraphRequest
 */
export interface AdminApiUpdateMetadataGraphRequest {
    /**
     * The absolute URI of the graph to update.
     * @type {string}
     * @memberof AdminApiUpdateMetadataGraph
     */
    readonly graph: string

    /**
     * The metadata update admin parameters.
     * @type {MetadataUpdateAdminParameters}
     * @memberof AdminApiUpdateMetadataGraph
     */
    readonly metadataUpdateAdminParameters?: MetadataUpdateAdminParameters
}

/**
 * AdminApi - object-oriented interface
 * @export
 * @class AdminApi
 * @extends {BaseAPI}
 */
export class AdminApi extends BaseAPI {
    /**
     * 
     * @summary Responds with the HTTP methods allowed for the endpoint.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AdminApi
     */
    public apiV2AdminOptions(options?: RawAxiosRequestConfig) {
        return AdminApiFp(this.configuration).apiV2AdminOptions(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
     * @summary Retrieves all activity logs.
     * @param {AdminApiGetAllActivityLogsRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AdminApi
     */
    public getAllActivityLogs(requestParameters: AdminApiGetAllActivityLogsRequest = {}, options?: RawAxiosRequestConfig) {
        return AdminApiFp(this.configuration).getAllActivityLogs(requestParameters.activityTimestampBefore, requestParameters.activityTimestampAfter, requestParameters.guid, requestParameters.userId, requestParameters.regularExpression, requestParameters.httpMethod, requestParameters.pageNumber, requestParameters.pageSize, requestParameters.orderBy, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
     * @summary Retrieves all projects.
     * @param {AdminApiGetAllProjectsRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AdminApi
     */
    public getAllProjects(requestParameters: AdminApiGetAllProjectsRequest = {}, options?: RawAxiosRequestConfig) {
        return AdminApiFp(this.configuration).getAllProjects(requestParameters.topLevel, requestParameters.includeDeleted, requestParameters.includeQuotas, requestParameters.includePublicationRequests, requestParameters.pageSize, requestParameters.pageNumber, requestParameters.orderBy, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
     * @summary Retrieves all resources.
     * @param {AdminApiGetAllResourcesRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AdminApi
     */
    public getAllResources(requestParameters: AdminApiGetAllResourcesRequest = {}, options?: RawAxiosRequestConfig) {
        return AdminApiFp(this.configuration).getAllResources(requestParameters.includeDeleted, requestParameters.includeQuotas, requestParameters.pageSize, requestParameters.pageNumber, requestParameters.orderBy, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
     * @summary Retrieves all users.
     * @param {AdminApiGetAllUsersRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AdminApi
     */
    public getAllUsers(requestParameters: AdminApiGetAllUsersRequest = {}, options?: RawAxiosRequestConfig) {
        return AdminApiFp(this.configuration).getAllUsers(requestParameters.tosAccepted, requestParameters.pageSize, requestParameters.pageNumber, requestParameters.orderBy, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
     * @summary Gets all deployed graphs.
     * @param {AdminApiGetDeployedGraphsRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AdminApi
     */
    public getDeployedGraphs(requestParameters: AdminApiGetDeployedGraphsRequest = {}, options?: RawAxiosRequestConfig) {
        return AdminApiFp(this.configuration).getDeployedGraphs(requestParameters.pageNumber, requestParameters.pageSize, requestParameters.orderBy, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
     * @summary Gets a metadata graph.
     * @param {AdminApiGetMetadataGraphRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AdminApi
     */
    public getMetadataGraph(requestParameters: AdminApiGetMetadataGraphRequest, options?: RawAxiosRequestConfig) {
        return AdminApiFp(this.configuration).getMetadataGraph(requestParameters.graph, requestParameters.format, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
     * @summary Patches a metadata graph.
     * @param {AdminApiPatchMetadataRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AdminApi
     */
    public patchMetadata(requestParameters: AdminApiPatchMetadataRequest, options?: RawAxiosRequestConfig) {
        return AdminApiFp(this.configuration).patchMetadata(requestParameters.graph, requestParameters.rdfPatchDocumentDto, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
     * @summary Updates a metadata graph.
     * @param {AdminApiUpdateMetadataGraphRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AdminApi
     */
    public updateMetadataGraph(requestParameters: AdminApiUpdateMetadataGraphRequest, options?: RawAxiosRequestConfig) {
        return AdminApiFp(this.configuration).updateMetadataGraph(requestParameters.graph, requestParameters.metadataUpdateAdminParameters, options).then((request) => request(this.axios, this.basePath));
    }
}

